Index: src/UIElements/CommandLineUI/CommandLineDialog.cpp
===================================================================
--- src/UIElements/CommandLineUI/CommandLineDialog.cpp	(revision a881f5b49bdbb93ecd4c8ff5c5d3e58eea5101f6)
+++ src/UIElements/CommandLineUI/CommandLineDialog.cpp	(revision d223d5e07c484fa4ef7f54e88e97fa78b5c0b504)
@@ -23,8 +23,8 @@
 #include "CommandLineParser.hpp"
 #include "defs.hpp"
-#include "log.hpp"
-#include "Matrix.hpp"
+#include "Helpers/Log.hpp"
+#include "LinearAlgebra/Matrix.hpp"
 #include "periodentafel.hpp"
-#include "verbose.hpp"
+#include "Helpers/Verbose.hpp"
 #include "World.hpp"
 #include "Box.hpp"
@@ -33,5 +33,5 @@
 #include "element.hpp"
 #include "molecule.hpp"
-#include "vector.hpp"
+#include "LinearAlgebra/Vector.hpp"
 
 using namespace std;
Index: src/UIElements/Dialog.cpp
===================================================================
--- src/UIElements/Dialog.cpp	(revision a881f5b49bdbb93ecd4c8ff5c5d3e58eea5101f6)
+++ src/UIElements/Dialog.cpp	(revision d223d5e07c484fa4ef7f54e88e97fa78b5c0b504)
@@ -9,12 +9,12 @@
 
 #include "Dialog.hpp"
-#include "ValueStorage.hpp"
-
-#include "verbose.hpp"
+#include "Actions/ValueStorage.hpp"
+
+#include "Helpers/Verbose.hpp"
 #include "atom.hpp"
 #include "element.hpp"
 #include "molecule.hpp"
-#include "vector.hpp"
-#include "Matrix.hpp"
+#include "LinearAlgebra/Vector.hpp"
+#include "LinearAlgebra/Matrix.hpp"
 #include "Box.hpp"
 
Index: src/UIElements/Dialog.hpp
===================================================================
--- src/UIElements/Dialog.hpp	(revision a881f5b49bdbb93ecd4c8ff5c5d3e58eea5101f6)
+++ src/UIElements/Dialog.hpp	(revision d223d5e07c484fa4ef7f54e88e97fa78b5c0b504)
@@ -14,5 +14,5 @@
 
 #include "Box.hpp"
-#include "vector.hpp"
+#include "LinearAlgebra/Vector.hpp"
 
 class atom;
Index: src/UIElements/Makefile.am
===================================================================
--- src/UIElements/Makefile.am	(revision a881f5b49bdbb93ecd4c8ff5c5d3e58eea5101f6)
+++ src/UIElements/Makefile.am	(revision d223d5e07c484fa4ef7f54e88e97fa78b5c0b504)
@@ -5,7 +5,4 @@
 AM_LDFLAGS = $(CPPUNIT_LIBS) -ldl
 AM_CXXFLAGS = $(CPPUNIT_CFLAGS)
-
-noinst_LIBRARIES = libMolecuilderUI.a
-libMolecuilderUI_a_SOURCES = ${UISOURCE} ${UIHEADER}
 
 VIEWSOURCE = \
@@ -45,6 +42,5 @@
   ${VIEWSOURCE} \
   Dialog.cpp \
-  MainWindow.cpp \
-  ValueStorage.cpp
+  MainWindow.cpp
   
 UIHEADER = \
@@ -55,6 +51,5 @@
   ${VIEWHEADER} \
   Dialog.hpp \
-  MainWindow.hpp \
-  ValueStorage.hpp
+  MainWindow.hpp
 
 TEXTUISOURCE = \
@@ -80,4 +75,47 @@
   CommandLineUI/CommandLineWindow.hpp
 
+lib_LTLIBRARIES = libMolecuilderUI-@MOLECUILDER_API_VERSION@.la
+libMolecuilderUI_includedir = $(includedir)/molecuilder-$(MOLECUILDER_API_VERSION)/Actions/
+libMolecuilderUI_LIBS = \
+	Actions/libMolecuilderActions-@MOLECUILDER_API_VERSION@.la
+
+nobase_libMolecuilderUI_include_HEADERS = ${UIHEADER}
+
+## Define the source file list for the "libexample-@MOLECUILDER_API_VERSION@.la"
+## target.  Note that @MOLECUILDER_API_VERSION@ is not interpreted by Automake and
+## will therefore be treated as if it were literally part of the target name,
+## and the variable name derived from that.
+## The file extension .cc is recognized by Automake, and makes it produce
+## rules which invoke the C++ compiler to produce a libtool object file (.lo)
+## from each source file.  Note that it is not necessary to list header files
+## which are already listed elsewhere in a _HEADERS variable assignment.
+libMolecuilderUI_@MOLECUILDER_API_VERSION@_la_SOURCES = ${UISOURCE}
+
+## Instruct libtool to include ABI version information in the generated shared
+## library file (.so).  The library ABI version is defined in configure.ac, so
+## that all version information is kept in one place.
+libMolecuilderUI_@MOLECUILDER_API_VERSION@_la_LDFLAGS = -version-info $(MOLECUILDER_SO_VERSION)
+
+## The generated configuration header is installed in its own subdirectory of
+## $(libdir).  The reason for this is that the configuration information put
+## into this header file describes the target platform the installed library
+## has been built for.  Thus the file must not be installed into a location
+## intended for architecture-independent files, as defined by the Filesystem
+## Hierarchy Standard (FHS).
+## The nodist_ prefix instructs Automake to not generate rules for including
+## the listed files in the distribution on 'make dist'.  Files that are listed
+## in _HEADERS variables are normally included in the distribution, but the
+## configuration header file is generated at configure time and should not be
+## shipped with the source tarball.
+libMolecuilderUI_libincludedir = $(libdir)/molecuilder-$(MOLECUILDER_API_VERSION)/include
+nodist_libMolecuilderUI_libinclude_HEADERS = $(top_builddir)/libmolecuilder_config.h
+
+## Install the generated pkg-config file (.pc) into the expected location for
+## architecture-dependent package configuration information.  Occasionally,
+## pkg-config files are also used for architecture-independent data packages,
+## in which case the correct install location would be $(datadir)/pkgconfig.
+pkgconfigdir = $(libdir)/pkgconfig
+pkgconfig_DATA = $(top_builddir)/molecuilder-$(MOLECUILDER_API_VERSION).pc
+
 unity.cpp:
 	echo "" >  unity.cpp; \
Index: src/UIElements/QT4/IntQTQuery.ui
===================================================================
--- src/UIElements/QT4/IntQTQuery.ui	(revision d223d5e07c484fa4ef7f54e88e97fa78b5c0b504)
+++ src/UIElements/QT4/IntQTQuery.ui	(revision d223d5e07c484fa4ef7f54e88e97fa78b5c0b504)
@@ -0,0 +1,68 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<ui version="4.0">
+ <class>Form</class>
+ <widget class="QWidget" name="Form">
+  <property name="geometry">
+   <rect>
+    <x>0</x>
+    <y>0</y>
+    <width>400</width>
+    <height>300</height>
+   </rect>
+  </property>
+  <property name="windowTitle">
+   <string>Form</string>
+  </property>
+  <widget class="QLabel" name="label">
+   <property name="geometry">
+    <rect>
+     <x>20</x>
+     <y>30</y>
+     <width>59</width>
+     <height>17</height>
+    </rect>
+   </property>
+   <property name="text">
+    <string>TextLabel</string>
+   </property>
+  </widget>
+  <widget class="QLineEdit" name="lineEdit">
+   <property name="geometry">
+    <rect>
+     <x>100</x>
+     <y>20</y>
+     <width>113</width>
+     <height>27</height>
+    </rect>
+   </property>
+  </widget>
+  <widget class="QPushButton" name="pushButton">
+   <property name="geometry">
+    <rect>
+     <x>20</x>
+     <y>70</y>
+     <width>92</width>
+     <height>27</height>
+    </rect>
+   </property>
+   <property name="text">
+    <string>OK</string>
+   </property>
+  </widget>
+  <widget class="QPushButton" name="pushButton_2">
+   <property name="geometry">
+    <rect>
+     <x>140</x>
+     <y>70</y>
+     <width>92</width>
+     <height>27</height>
+    </rect>
+   </property>
+   <property name="text">
+    <string>Cancel</string>
+   </property>
+  </widget>
+ </widget>
+ <resources/>
+ <connections/>
+</ui>
Index: src/UIElements/QT4/IntsQTQuery.ui
===================================================================
--- src/UIElements/QT4/IntsQTQuery.ui	(revision d223d5e07c484fa4ef7f54e88e97fa78b5c0b504)
+++ src/UIElements/QT4/IntsQTQuery.ui	(revision d223d5e07c484fa4ef7f54e88e97fa78b5c0b504)
@@ -0,0 +1,151 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<ui version="4.0">
+ <class>Form</class>
+ <widget class="QWidget" name="Form">
+  <property name="geometry">
+   <rect>
+    <x>0</x>
+    <y>0</y>
+    <width>740</width>
+    <height>444</height>
+   </rect>
+  </property>
+  <property name="windowTitle">
+   <string>Form</string>
+  </property>
+  <widget class="QWidget" name="horizontalLayoutWidget">
+   <property name="geometry">
+    <rect>
+     <x>10</x>
+     <y>240</y>
+     <width>421</width>
+     <height>51</height>
+    </rect>
+   </property>
+   <layout class="QHBoxLayout" name="horizontalLayout">
+    <item>
+     <spacer name="horizontalSpacer">
+      <property name="orientation">
+       <enum>Qt::Horizontal</enum>
+      </property>
+      <property name="sizeHint" stdset="0">
+       <size>
+        <width>40</width>
+        <height>20</height>
+       </size>
+      </property>
+     </spacer>
+    </item>
+    <item>
+     <widget class="QPushButton" name="pushButton">
+      <property name="text">
+       <string>OK</string>
+      </property>
+     </widget>
+    </item>
+    <item>
+     <widget class="QPushButton" name="pushButton_2">
+      <property name="text">
+       <string>Cancel</string>
+      </property>
+     </widget>
+    </item>
+   </layout>
+  </widget>
+  <widget class="QWidget" name="verticalLayoutWidget">
+   <property name="geometry">
+    <rect>
+     <x>280</x>
+     <y>0</y>
+     <width>160</width>
+     <height>221</height>
+    </rect>
+   </property>
+   <layout class="QVBoxLayout" name="verticalLayout">
+    <item>
+     <widget class="QLabel" name="label">
+      <property name="text">
+       <string>Enter Integer:</string>
+      </property>
+      <property name="buddy">
+       <cstring>lineEdit</cstring>
+      </property>
+     </widget>
+    </item>
+    <item>
+     <widget class="QLineEdit" name="lineEdit">
+      <property name="minimumSize">
+       <size>
+        <width>100</width>
+        <height>20</height>
+       </size>
+      </property>
+      <property name="toolTip">
+       <string>Enter an integer and press Add.</string>
+      </property>
+     </widget>
+    </item>
+    <item>
+     <widget class="QPushButton" name="pushButton_3">
+      <property name="enabled">
+       <bool>false</bool>
+      </property>
+      <property name="text">
+       <string>Add</string>
+      </property>
+     </widget>
+    </item>
+    <item>
+     <widget class="QPushButton" name="pushButton_4">
+      <property name="enabled">
+       <bool>false</bool>
+      </property>
+      <property name="text">
+       <string>Remove</string>
+      </property>
+     </widget>
+    </item>
+    <item>
+     <spacer name="verticalSpacer">
+      <property name="orientation">
+       <enum>Qt::Vertical</enum>
+      </property>
+      <property name="sizeHint" stdset="0">
+       <size>
+        <width>20</width>
+        <height>40</height>
+       </size>
+      </property>
+     </spacer>
+    </item>
+   </layout>
+  </widget>
+  <widget class="QWidget" name="verticalLayoutWidget_2">
+   <property name="geometry">
+    <rect>
+     <x>10</x>
+     <y>0</y>
+     <width>261</width>
+     <height>221</height>
+    </rect>
+   </property>
+   <layout class="QVBoxLayout" name="verticalLayout_2">
+    <item>
+     <widget class="QLabel" name="label_2">
+      <property name="text">
+       <string>Current List of Integers:</string>
+      </property>
+     </widget>
+    </item>
+    <item>
+     <widget class="QListWidget" name="listWidget"/>
+    </item>
+   </layout>
+  </widget>
+ </widget>
+ <tabstops>
+  <tabstop>pushButton</tabstop>
+ </tabstops>
+ <resources/>
+ <connections/>
+</ui>
Index: src/UIElements/QT4/QTDialog.cpp
===================================================================
--- src/UIElements/QT4/QTDialog.cpp	(revision a881f5b49bdbb93ecd4c8ff5c5d3e58eea5101f6)
+++ src/UIElements/QT4/QTDialog.cpp	(revision d223d5e07c484fa4ef7f54e88e97fa78b5c0b504)
@@ -35,5 +35,5 @@
 #include "Descriptors/AtomIdDescriptor.hpp"
 #include "Descriptors/MoleculeIdDescriptor.hpp"
-#include "Matrix.hpp"
+#include "LinearAlgebra/Matrix.hpp"
 #include "Box.hpp"
 
Index: src/UIElements/QT4/QTMainWindow.cpp
===================================================================
--- src/UIElements/QT4/QTMainWindow.cpp	(revision a881f5b49bdbb93ecd4c8ff5c5d3e58eea5101f6)
+++ src/UIElements/QT4/QTMainWindow.cpp	(revision d223d5e07c484fa4ef7f54e88e97fa78b5c0b504)
@@ -21,5 +21,5 @@
 #include "atom.hpp"
 #include "molecule.hpp"
-#include "verbose.hpp"
+#include "Helpers/Verbose.hpp"
 #include "Actions/Action.hpp"
 #include "Actions/ActionRegistry.hpp"
Index: src/UIElements/TextUI/TextDialog.cpp
===================================================================
--- src/UIElements/TextUI/TextDialog.cpp	(revision a881f5b49bdbb93ecd4c8ff5c5d3e58eea5101f6)
+++ src/UIElements/TextUI/TextDialog.cpp	(revision d223d5e07c484fa4ef7f54e88e97fa78b5c0b504)
@@ -19,12 +19,12 @@
 #include "World.hpp"
 #include "periodentafel.hpp"
-#include "log.hpp"
-#include "verbose.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
 
 #include "atom.hpp"
 #include "element.hpp"
 #include "molecule.hpp"
-#include "vector.hpp"
-#include "Matrix.hpp"
+#include "LinearAlgebra/Vector.hpp"
+#include "LinearAlgebra/Matrix.hpp"
 #include "Box.hpp"
 
Index: src/UIElements/TextUI/TextWindow.cpp
===================================================================
--- src/UIElements/TextUI/TextWindow.cpp	(revision a881f5b49bdbb93ecd4c8ff5c5d3e58eea5101f6)
+++ src/UIElements/TextUI/TextWindow.cpp	(revision d223d5e07c484fa4ef7f54e88e97fa78b5c0b504)
@@ -27,6 +27,6 @@
 
 #include "defs.hpp"
-#include "log.hpp"
-#include "verbose.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
 
 // all needed due to config::SaveAll()
Index: src/UIElements/ValueStorage.cpp
===================================================================
--- src/UIElements/ValueStorage.cpp	(revision a881f5b49bdbb93ecd4c8ff5c5d3e58eea5101f6)
+++ 	(revision )
@@ -1,20 +1,0 @@
-/*
- * ValueStorage.cpp
- *
- *  Created on: Jul 22, 2010
- *      Author: heber
- */
-
-
-#include "ValueStorage.hpp"
-#include "Patterns/Singleton_impl.hpp"
-
-ValueStorage::ValueStorage() {};
-
-ValueStorage::~ValueStorage() {};
-
-std::string ValueStorage::getDescription(std::string actionname) {
-  return MapOfActions::getInstance().getDescription(actionname);
-}
-
-CONSTRUCT_SINGLETON(ValueStorage)
Index: src/UIElements/ValueStorage.hpp
===================================================================
--- src/UIElements/ValueStorage.hpp	(revision a881f5b49bdbb93ecd4c8ff5c5d3e58eea5101f6)
+++ 	(revision )
@@ -1,38 +1,0 @@
-/*
- * ValueStorage.hpp
- *
- *  Created on: Jul 22, 2010
- *      Author: heber
- */
-
-#ifndef VALUESTORAGE_HPP_
-#define VALUESTORAGE_HPP_
-
-
-#include "Actions/MapOfActions.hpp"
-#include "Patterns/Singleton.hpp"
-
-/** ValueStorage serves as a mediator to MapOfActions.
- * This is needed to relax inter-dependencies between the Queries and the Actions.
- * I.e. this is the interface implemented in MapOfActions which both can safely rely on
- * to store&retrieve/exchange values.
- */
-class ValueStorage : public Singleton<ValueStorage> {
-  friend class Singleton<ValueStorage>;
-
-public:
-  template <typename T> void queryCurrentValue(const char *name, T &_T) {
-    MapOfActions::getInstance().queryCurrentValue(name, _T);
-  }
-  template <typename T> void setCurrentValue(const char *name, T &_T) {
-    MapOfActions::getInstance().setCurrentValue(name, _T);
-  }
-
-  std::string getDescription(std::string actionname);
-
-protected:
-  ValueStorage();
-  ~ValueStorage();
-};
-
-#endif /* VALUESTORAGE_HPP_ */
Index: src/UIElements/Views/QT4/QTStatusBar.cpp
===================================================================
--- src/UIElements/Views/QT4/QTStatusBar.cpp	(revision a881f5b49bdbb93ecd4c8ff5c5d3e58eea5101f6)
+++ src/UIElements/Views/QT4/QTStatusBar.cpp	(revision d223d5e07c484fa4ef7f54e88e97fa78b5c0b504)
@@ -14,5 +14,5 @@
 #include "QTStatusBar.hpp"
 #include "World.hpp"
-#include "helpers.hpp"
+#include "Helpers/helpers.hpp"
 #include "Actions/Process.hpp"
 
